(library (copy-term)
  (export copy-termo)
  (import (ikarus) (alphaK))
  
(define var
  (lambda (n)
    (make-var n '())))

(define copy-walk
  (lambda (v s)
    (cond
      ((var? v)
       (let ((a (assq v s)))
         (cond
           (a (copy-walk (cdr a) s))
           (else v))))
      (else v))))

(define copy-walk*
  (lambda (w s)
    (let ((v (copy-walk w s)))
      (cond
        ((var? v) v)
        ((pair? v)
         (cons
           (copy-walk* (car v) s)
           (copy-walk* (cdr v) s)))
        (else v)))))


(define refresh-s
  (lambda (v s)
    (let ((v (copy-walk v s)))
      (cond
        ((var? v)
         (cons (cons v (var 'copy)) s))
        ((pair? v) (refresh-s (cdr v)
                     (refresh-s (car v) s)))
        (else s)))))

(define copy-termo
  (lambda (t1 t2)
    (project (t1)
      (== (copy-walk* t1 (refresh-s t1 '())) t2))))
)
