(library (mkleantap)
  (export proveo do-prove-th A E)
  (import (ikarus) (alphaK) (nnf) (copy-term))

(define membero
  (lambda (x ls)
    (conde
      ((exist (d)
         (==-check `(,x . ,d) ls)))
      ((exist (a d)
         (== `(,a . ,d) ls)
         (membero x d))))))

(define appendo 
  (lambda (l1 l2 l3)
    (conde
      ((== l1 '()) (== l2 l3))
      ((exist (x l11 l31)
         (== l1 (cons x l11))
         (== l3 (cons x l31))
         (appendo l11 l2 l31))))))


(define proveo
  (lambda (fml unexp lits freev)
    (conda
      ((exist (a b)
         (== `(and ,a ,b) fml)
         (proveo a (cons b unexp) lits freev)))
      ((exist (a b)
         (== `(or ,a ,b) fml)
         (proveo a unexp lits freev)
         (proveo b unexp lits freev)))
      ((exist (x x1 b b1 unexp1)
         (== `(forall ,x ,b) fml)
         (copy-termo `(,x ,b ,freev) `(,x1 ,b1 ,freev))
         (appendo unexp (list fml) unexp1)
         (proveo b1 unexp1 lits (cons x1 freev))))
      ((conde
         ((exist (l rest neg)
            (conda
              ((== `(not ,neg) fml)) ((== `(not ,fml) neg)))
            (membero neg lits)))
         ((exist (next unexp1)
            (== `(,next . ,unexp1) unexp)
            (proveo next unexp1 (cons fml lits) freev))))))))




(define (do-prove-th axioms theorem)
  (let* ((nf (prepare axioms theorem)))
    (printf "NNF is: \n")
    (pretty-print nf) (newline)
    (let ((pr (run 1 (q) (proveo nf '() '() '()))))
      (if (null? pr) (error 'prove "failure!"))
      pr)))

)