

expando(lit(X), lit(X)).
expando((A,B), (Ap,Bp)) :- expando(A, Ap), expando(B, Bp).
expando((A;B), (Ap;Bp)) :- expando(A, Ap), expando(B, Bp).
expando(all(X, Fml), all(X, Fmlp)) :-
 gensym(u, X), expando(Fml, Fmlp).
    
proveo(X, Proof) :- expando(X, Y), iterate(Y, 0, Proof, _).
proveo(X, Proof, VarLim) :- expando(X, Y), iterate(Y, 0, Proof, VarLim).

iterate(Fml, VarLim, Proof, VarLim) :- proveo(Fml, [], [], [], VarLim, Proof).
iterate(Fml, VarLim, Proof, Out) :-
 NVarLim is VarLim + 1,
 iterate(Fml, NVarLim, Proof, Out).
    
proveo((A,B), UnExp, Lits, Env, VarLim, [conj|P]) :-
 proveo(A, [B|UnExp], Lits, Env, VarLim, P).

proveo((A;B), UnExp, Lits, Env, VarLim, [split, P1, P2]) :-
 proveo(A, UnExp, Lits, Env, VarLim, P1),
 proveo(B, UnExp, Lits, Env, VarLim, P2).

proveo(all(X, Fml), UnExp, Lits, Env, VarLim, [univ|P]) :-
 \+ VarLim is 0,
 NVarLim is VarLim - 1,
 append(UnExp, [all(X, Fml)], UnExp1),
 proveo(Fml, UnExp1, Lits, [[X, _]|Env], NVarLim, P).


proveo(lit(X), _, Lits, Env, _, [close]) :-
 negateo(X, Neg),
 subst(Neg, Env, New),
 membero(New, Lits).

proveo(lit(X), [Next|UnExp], Lits, Env, VarLim, [savefml|P]) :-
 subst(X, Env, Lit),
 proveo(Next, UnExp, [Lit|Lits], Env, VarLim, P).

negateo(pos(X), not(X)).
negateo(not(X), pos(X)).

subst(pos(X), Env, pos(Y)) :- substlit(X, Env, Y).
subst(not(X), Env, not(Y)) :- substlit(X, Env, Y).

substlit(sym(X), _, sym(X)).
substlit(var(X), Env, Y) :- lookupo(X, Env, Y).
substlit(app([F|D]), Env, app([F|DN])) :- subst*(D, Env, DN).

subst*([], _, []).
subst*([A|D], Env, [R1|R2]) :-
 substlit(A, Env, R1), subst*(D, Env, R2).

lookupo(X, [[X, Y]|_], Y).
lookupo(X, [A|D], R) :- dif(X, A), lookupo(X, D, R).

membero(X, [A|_]) :- unify_with_occurs_check(X, A).
membero(X, [_|D]) :- membero(X, D).

